<?php
# Subroutine: adm_board.php called by Admin.php
# Xinfeng Chen, 2002.11.19

require_once('bin/config.php');
require_once('admin/adm.inc');

#--- Validate dministrator ---
include('admin/adm_validate.php');
if(!$adm_validated){jumpTo('admin.php?cmd=logon'); exit;}

#--- Start Processing ---
require_once('core/class_forum_base.php');
CForumBase::setFileBase("$filepath");
require_once('core/base_array_file.php');
require_once('core/class_board_list.php');
require_once('core/base_memo_file.php');
require_once('core/class_board.php');
require_once('core/base_record_file.php');
require_once('core/class_topic_list.php');
require_once('core/base_index_file.php');
require_once('core/class_topic_index.php');

page_header();

print <<<EOT
<h1>ע̳</h1>
<p>ؽ̳עļ̳޸ġ̳ļ޸</p>
<table class="forumline" align="center" width="100%">
  <tr> 
    <th colspan="4" class="thHead">̳ļ</th>
  </tr>
EOT;

#--- Generate info of board list data file ---
$blistpath=CForumBase::getFilePath('BLIST');
$blname=basename($blistpath);
$oBrdLst=new CBoardList;
if($oBrdLst->load()){
 $blsize=$oBrdLst->itemcount();
 $blstat='';
}else{
 $blsize='N/A';
 $blstat='ʧ';
}

print <<<EOT
  <tr> 
    <td class="row2">ļ: $blname</td>
    <td class="row1">Ϣ:  $blsize ̳Ϣ</td>
    <td class="row1">״̬: $blstat</td>
    <td class="row1"><a href=?cmd=blist_resync>ؽ</a></td>
  </tr>
</table>
EOT;

print <<<EOT
<br>
<table class="forumline" align="center" width="100%">
  <tr> 
    <th colspan="6" class="thHead">̳б</th>
  </tr>
  <tr> 
    <th class="thHead">̳ID</th>
    <th class="thHead">/</th>
    <th class="thHead">ļ״̬</th>
    <th class="thHead">&nbsp;</th>
    <th class="thHead">&nbsp;</th>
  </tr>
EOT;

#--- Generate info for each board ---
if($blsize=='N/A'){$blsize=0;}
for($ii=0; $ii<$blsize; $ii++){
 $oBrdLst->moveTo($ii);
 _printBoardInfo($oBrdLst->id);
}

print '</table>';

page_footer();
exit;

function _printBoardInfo($bid){

 $oBrd=new CBoard;
 if($oBrd->load($bid)){
  $bname=$oBrd->name;
  $bdesc=$oBrd->desc;
  $bstat='[<font color=green>Ϣ</font>]';
 }else{
  $bname=$bdesc='N/A';
  $bstat='[<font color=red>Ϣ</font>]';
 }

 $oTpcLst=new CTopicList;
 $bcstat=$oTpcLst->open($bid) ?
  '[<font color=green>б</font>]' : '[<font color=red>б</font>]';
 $oTpcLst->close();

 $oTpcIdx=new CTopicIndex;
 $bistat=$oTpcIdx->open($bid) ? 
  '[<font color=green></font>]' : '[<font color=red></font>]';
 $oTpcIdx->close();

 print <<<EOT
<tr>
 <td class="row1">$bid</td>
 <td class="row1"><b>$bname</b><br>$bdesc</td>
 <td class="row1" width=105>$bstat$bcstat$bistat</td>
 <td class="row1" width=30><a href="?cmd=board_form&bid=$bid">༭</a></td>
 <td class="row1" width=45><a href="?cmd=board_reindex&bid=$bid"></a></td>
</tr>
EOT;

}
?>