<?php
# Subroutine: adm_restore_confirm.php called by Admin.php
# Xinfeng Chen, 2002.12.20
# Input: $file

require_once('bin/config.php');
require_once('admin/adm.inc');

#--- Validate dministrator ---
include('admin/adm_validate.php');
if(!$adm_validated){jumpTo('admin.php?cmd=logon'); exit;}

#--- Start Processing ---
require_once('core/class_forum_base.php');
CForumBase::setFileBase("$filepath");

#--- Check specified backup files ---
$backupPath=CForumBase::getDirPath('BACKUP');

$fname="$backupPath/$file";
if(!file_exists($fname) && !is_file($fname)){
 msgBox("ļ޷ִлԭ!",mCRITICAL);
 exit;
}

$fsize=ceil(filesize($fname)/1024);
$fp=fopen($fname,'rb');
$head=fread($fp,64);
fclose($fp);

list($tag,$bscope,$bid,$bts,$buser)=explode('|',$head);
$btime=strftime("%Y-%m-%d %H:%M:%S",$bts);
if($bscope != 'BOARD'){$bid='';}

switch($bscope){
 case 'ALL': $dirpath=CForumBase::getDirPath('BASE');break; 
 case 'BOARD':
  if(!$bid){
   msgBox("ָֹ̳ԭ",mCRITICAL);
   exit;
  }
  $dirpath=CForumBase::getDirPath('BOARD',$bid);break; 
 case 'USER': $dirpath=CForumBase::getDirPath('USER');break;
 default:
  msgBox("ݲԴֹԭ",mCRITICAL);
  exit;
}

$msg='ļ.<br>';
$msg.="ļС: $fsize K<br>";
$msg.="ʱ: $btime<br>";
$msg.="ִû: $buser<br>";
$msg.="ݲ: $bscope<br>";
$msg.="̳ID: $bid<br><br>";

if(file_exists($dirpath)){
 $msg.="ԭĿ Ѵڡ<font color=red>ԭǵǰݣ</font><br>";
}else{
 $msg.="ԭĿ ڡԭӦĿ¼<br>";
}

msgBox($msg,mINFORMATION,'ȷϻԭ',
 "?cmd=restore_submit&file=$file", 'ִлԭ');

?>