<?php
#------------------------------------------------------#
#               ΪzChain.netṩ                 #
#                zChain̳(ZBB)v2.00                  #
#------------------------------------------------------#
# INPUT: $action,$bid,$tid,$f_tobid,$f_move

require "bin/config.php";
require "bin/common.php";

require_once('core/class_forum_base.php');
CForumBase::setFileBase("$filepath");
require_once('core/base_memo_file.php');
require_once('core/class_board.php');
require_once('core/class_topic.php');
require_once('core/base_record_file.php');
require_once('core/class_topic_list.php');
require_once('core/base_index_file.php');
require_once('core/class_topic_index.php');

#--- log the event to trace attack ---
require_once('core/class_log.php');
CLOG::writeLogEntry("TopicMgr[action=$action,bid=$bid,tid=$tid] is called by user [$sv_user]");

$bid=str_replace(".", "", $bid);
$tid=str_replace(".", "", $tid);

#--- Validate user ---
$oBrd=new CBoard;
if(!$oBrd->load($bid)){errorview('ָ̳');}
if(!$oBrd->isModerator($sv_user)){errorview("ԲûдȨޣ");}

$oTpc=new CTopic;
if(!$oTpc->load($bid,$tid)){errorview("topic error!");}

$oTpcLst=new CTopicList;
$oTpcIdx=new CTopicIndex;

switch($action){
 case 'lock':
  $oTpc->locked=1; $oTpc->store($bid,$tid);
  _updateList($bid,&$oTpc);
  okview("ѾرգٽµĻظ");
  exit;
 case 'unlock':
  $oTpc->locked=0; $oTpc->store($bid,$tid);
  _updateList($bid,&$oTpc);
  okview("Ѿţɻظ");
  exit;
 case 'collect':
  $oTpc->setFlag('COLLECTED'); $oTpc->store($bid,$tid);
  _updateList($bid,&$oTpc);

  if($oTpcIdx->open($bid)){
   $oTpcIdx->selectIndex(2); $oTpcIdx->activateTopic($oTpc->refid);
   $oTpcIdx->close();
  }
  okview("Ѿӵ");
  exit;
 case 'uncollect':
  $oTpc->setFlag('COLLECTED',false); $oTpc->store($bid,$tid);
  _updateList($bid,&$oTpc);

  if($oTpcIdx->open($bid)){
   $oTpcIdx->selectIndex(2); $oTpcIdx->deleteTopic($oTpc->refid);
   $oTpcIdx->close();
  }
  okview("ѾѾɹƳ");
  exit;
 case 'settop':
  $oTpc->setFlag('TOPPED',true); $oTpc->store($bid,$tid);
  _updateList($bid,&$oTpc);

  if($oTpcIdx->open($bid)){
   $oTpcIdx->selectIndex(0); $oTpcIdx->deleteTopic($oTpc->refid);
   $oTpcIdx->selectIndex(1); $oTpcIdx->activateTopic($oTpc->refid);
   $oTpcIdx->close();
  }
  okview("Ѿɹöˣ");
  exit;
 case 'unsettop':
  $oTpc->setFlag('TOPPED',false); $oTpc->store($bid,$tid);
  _updateList($bid,&$oTpc);

  if($oTpcIdx->open($bid)){
   $oTpcIdx->selectIndex(1); $oTpcIdx->deleteTopic($oTpc->refid);
   $oTpcIdx->selectIndex(0); $oTpcIdx->activateTopic($oTpc->refid);
   $oTpcIdx->close();
  }
  okview("Ѿȡö");
  exit;
 case 'activate':
  $idx=($oTpc->getFlag('TOPPED')) ? 1 : 0;
  if($oTpcIdx->open($bid)){
   $oTpcIdx->selectIndex($idx); $oTpcIdx->activateTopic($oTpc->refid);
   $oTpcIdx->close();
  }
  okview("Ѿɹǰ");
  exit;
 case 'move':
  move_form($bid,$tid);
  exit;
 case 'movecommit':
  move_commit($tid,$bid,$f_tobid,$f_move);
  jumpto("viewboard.php?bid=$bid","Ѿɹؽƶѡ̳ˣԺϵͳԶ......");
  exit;
 default:
  errorview("unknow/not implemented action!");
  exit;
}

function _updateList($bid,$oTpc)
{
  $oTpcLst=new CTopicList;
  if($oTpcLst->open($bid)){
   $oTpcLst->updateTopic($oTpc->refid,$oTpc->id,$oTpc->getBrief());
   $oTpcLst->close();
  }
}

function move_form($bid, $tid)
{
 global $imgurl,$cgiurl,$ver;
 global $oBrd,$oTpc;

 require_once('core/base_array_file.php');
 require_once('core/class_board_list.php');
 $oBrdLst=new CBoardList;

 $flag=$oBrdLst->load();
 $moveSelection='<SELECT name=f_tobid><OPTION value="">ƶ</OPTION>';
 while($flag){
  $moveSelection.="<OPTION value=$oBrdLst->id>{$oBrdLst->name}";
  $flag=$oBrdLst->moveNext();
 }
 $moveSelection.='</SELECT>';

 page_header('ƶ',"$imgurl/bg.gif");
 print "<CENTER>";
 $posText=getRootText()." >> ƶ";
 menu_bar($posText,$hpurl);

 print <<<EOT
<SCRIPT>
var i=0;
function formCheck()
{
 i++; if (i>1) {alert('ƶУĵȴ'); return false;}
 return true;
}
</SCRIPT>
<br>
<form name=form method="POST" onSubmit="return formCheck()">
<INPUT TYPE="HIDDEN" NAME="action" VALUE=movecommit>
<INPUT TYPE="HIDDEN" NAME="bid" VALUE=$bid>
<INPUT TYPE="HIDDEN" NAME="tid" VALUE=$tid>
<table width="80%" border="0" cellspacing="2" cellpadding="2" align="center">
<tr>
 <td width="34%" align="left">̳{$oBrd->name}</td>
 <td width="66%">⣺{$oTpc->title}</td>
</tr>
</table>
<table width="80%" border="0" cellspacing="1" cellpadding="2" align="center" class="forumLine">
<tr>
 <td colspan="3" align="center" class="rowCaption"> ƶӹܣע⣺ֻӵдȨ)</td>
</tr>
<tr>
 <td class="row2" width="5%" valign="top"> 
  <input type="radio" checked></td>
 <td class="row2" width="67%"> תƵ̳ <br>
  ע: ѡ. ת֮ɾڵǰ̳򱣳ڵǰ̳. 
  <br><br>
  <input type="radio" name=f_move> ת֮󱣳ڵǰ̳.<br>
  <input type="radio" name=f_move checked value=1> ת֮ɾӵǰ̳.</td>
 <td class="row2" width="28%" valign="top" align="center"><br>
  $moveSelection<input type=submit value=" ȷ "></td>
</tr>
</table>
</form>
<div align="center"><a href=javascript:history.back()>
<IMG src=$imgurl/back.gif border=0></a>
EOT;

 page_footer();

}

function move_commit($tid, $bidfrom, $bidto, $move)
{
 global $oBrd,$oTpc;

 require_once('core/base_array_file.php');
 require_once('core/class_reply_set.php');
 $oRpl=new CReplySet;

 if(!$bidto){errorview("ѡҪƶĸ̳");}
 if($bidfrom == $bidto){return;}

 $oTpcLst=new CTopicList;
 $oTpcIdx=new CTopicIndex;
 $oTpcTest=new CTopic;

 #--- Check destination ---
 if(!$oTpcLst->open($bidto)){errorview('Ŀ̳');}
 if($oTpcTest->load($bidto,$tid)){errorview('Ŀ̳Ѵڣ');}

 #--- Copy topic to destination board ---
 $refid=$oTpc->refid;

 $oTpc->setFlag('TOPPED',false); $oTpc->setFlag('COLLECTED',false);
 if(!$oTpcLst->insertTopic($tid,$oTpc->getBrief())){errorview('бɴ');}

 $oTpc->refid=$oTpcLst->getAbsolutePosition();
 if(!$oTpc->store($bidto,$tid)){errorview('ļƴ');}
 if($oRpl->load($bidfrom,$oTpc->replyid)){
  if(!$oRpl->store($bidto,$oTpc->replyid)){errorview('ظļƴ');}
 }

 $oTpcLst->close();

 if($oTpcIdx->open($bidto)){
  $oTpcIdx->selectIndex(0); $oTpcIdx->activateTopic($oTpc->refid);
  $oTpcIdx->close();
 }

 #--- Process source board ---
 if($move == 1) {
  $oTpcLst->open($bidfrom);
  $oTpcLst->deleteTopic($refid,$tid);
  $oTpcLst->close();
  if($oTpcIdx->open($bidfrom)){
   $oTpcIdx->selectIndex(0); $oTpcIdx->deleteTopic($refid);
   $oTpcIdx->selectIndex(1); $oTpcIdx->deleteTopic($refid);
   $oTpcIdx->selectIndex(2); $oTpcIdx->deleteTopic($refid);
   $oTpcIdx->close();
  }
  #--- Delete topic ---
  $oRpl->destroy($bidfrom,$oTpc->replyid);
  $oTpc->destroy($bidfrom,$tid);
 }

}

?>